#!/usr/bin/perl

# despool.pl -q<spoolID> [...]

require '/usr/local/spoolerator/spool.pl';

foreach $id (@ARGV) {
  $id =~ s/^-qI//;

  open(QUEFILE, "$outgoing_spool/qf$id") || die("no such id as $id");

  $from = "";
  @to = ();
  $headers = "";
  while(<QUEFILE>) {
    chomp;
    $from = $1 if /^S(.+)$/;
    push(@to, $1) if /^R(.+)$/;
    $headers .= "$1\n" if /^H(.+)$/;
    $headers .= " $1\n" if /^\s(.+)$/;
  }

  close QUEFILE;

  $from = 'postmaster@pa.net' if ($from eq "");
  @to = ('root@localhost') if (!@to);
  $cmd = "/usr/sbin/sendmail";

  open(DATFILE, "$outgoing_spool/df$id") || die("no such id as $id");

  $pid = open(INSERT, "|-");  #fork
  $SIG{ALRM} = sub { die "pipe broke" };

  if ($pid) { #parent
    print INSERT "$headers\n";
    while (<DATFILE>) {
      print INSERT;
    }
    close INSERT || die "$cmd exited $?";
  } else { #child
    exec($cmd, '-f', $from, '--', @to) || die("cannot exec $cmd");
  }
  close DATFILE;

  unlink glob("$outgoing_spool/[qd]f$id"); 
}
